import Tool from "./tool";
import { graph, state } from "../editor";
import { TOOLS } from "../state";
import * as SelectMenu from "./menus/selectmenu";

export default class SelectTool extends Tool {
    constructor(key) {
        super("Select", "select", key, new SelectMenu.SelectMenu());
    }

    onNodeClick(node) {
        state.setSelectedItem(node);
        this.menu.value(SelectMenu.SELECTION_KEY, node);
    }

    onLinkClick(link) {
        state.setSelectedItem(link);
        this.menu.value(SelectMenu.SELECTION_KEY, link);
    }

    onBackgroundClick(event, positions) {
        state.setSelectedItem(undefined);
        this.menu.value(SelectMenu.SELECTION_KEY, {});
    }

    onMenuChange(key, value) {
        if (key === SelectMenu.SELECTION_KEY) {
            graph.changeDetails(value);
        }
    }

    onToolActivate() {
        if (state === undefined) {
            return;
        }

        var newSelection = state.selectedItem;
        if (newSelection === undefined) {
            newSelection = {};
        }

        this.menu.value(SelectMenu.SELECTION_KEY, newSelection);
    }
}
